import java.awt.*;
import java.applet.*;

public class Spinning extends Applet implements Runnable
{
  static final Color colors[] = {
    Color.red, Color.green, Color.blue, Color.yellow, Color.magenta, Color.cyan
  };
  int[] z;
  Color[] c;
  double[] t;
  double[] r;
  double theta;
  int numStars;
  Image buf;
  Image buf2;
  Thread thread;

  public void init()
  {
  }

  public void start()
  {
    buf = createImage(getSize().width, getSize().height);
    buf2 = createImage(getSize().width, getSize().height); 
    theta = 0;
    numStars = 100;
    z = new int[numStars];
    c = new Color[numStars];
    t = new double[numStars];
    r = new double[numStars];
    for (int i = 0; i < numStars; i++)
    {
      z[i] = (int)(Math.random() * getSize().height);
      c[i] = colors[(int)(Math.random() * colors.length)];
      t[i] = Math.random() * 2 * Math.PI;
      r[i] = Math.random() * getSize().width / 2;
    }
    if (thread == null)
    {
      thread = new Thread(this);
      thread.start();
    }
  }


  public void run()
  {
    try
    {
      Graphics g = getGraphics();
      while (true)
      {
        Thread.sleep(32);
        theta += Math.PI / 64;
        draw(buf2.getGraphics());
        Image t = buf;
        buf = buf2;
        buf2 = t;
        g.drawImage(buf, 0, 0, null);
      }
    } catch (InterruptedException e)
    {
    }
    catch (NullPointerException e)
    {
    }
    finally
    {
      thread = null;
    }
  }

  public void update(Graphics g)
  {
  }

  public void paint(Graphics g)
  {
    g.drawImage(buf, 0, 0, null);
  }

  public void draw(Graphics g)
  {
    g.setColor(Color.black);
    g.fillRect(0, 0, getSize().width, getSize().height);
    final int w =  getSize().width/2;
    final int w2 = getSize().width;
    for (int i = 0; i < numStars; i++)
    {
      final int y = (int)
           (r[i] * Math.sin(t[i] + theta) + w);
      final double x = r[i] * Math.cos(t[i] + theta);
      final int s = (int)((x / ((double)w2) + .5) * 8 + 1);  
      final int s2 = s/2;
      if (x > 0)
        g.setColor(c[i]);
      else
        g.setColor(c[i].darker());
      g.fillOval(y-s2, z[i]-s2, s, s); 
    }
  }
}
